import { E as EventBus, R as ReadonlyNonBasic, a as CreateOptions } from './provider-5Rp0Zru7.mjs';

declare const eventBus: EventBus;
declare function create<T>(initialState: ReadonlyNonBasic<T>, options?: CreateOptions): readonly [() => readonly [ReadonlyNonBasic<T>, (newValue: ((s: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>) | ReadonlyNonBasic<T>) => void, number], {
    readonly getState: () => ReadonlyNonBasic<T>;
    readonly setState: (newValue: ((s: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>) | ReadonlyNonBasic<T>) => void;
    readonly forceUpdate: () => void;
    readonly syncState: (newValue: ReadonlyNonBasic<T> | ((s: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>)) => void;
    readonly subscribe: (callback: (state: ReadonlyNonBasic<T>) => void) => () => void;
    readonly destroy: () => void;
}];
type Store = ReturnType<typeof create<any>>[1];
type StrictPropertyCheck<T> = Exclude<keyof T, keyof Omit<T, keyof Store>> extends never ? Omit<T, keyof Store> : {
    error: 'Extra properties detected';
    extraProperties: Exclude<keyof T, keyof Omit<T, keyof Store>>;
};

export { type Store as S, type StrictPropertyCheck as a, create as c, eventBus as e };
