import { R as ReadonlyNonBasic, a as CreateOptions, C as Cache, O as Options } from './provider-5Rp0Zru7.mjs';
export { E as EventBus, P as Provider, d as debounce, e as emitPersistReady, o as onPersistReady } from './provider-5Rp0Zru7.mjs';
import 'react';

/**
 * @deprecated Please use `create`, `createOne` will remove in 2.0
 */
declare const createOne: typeof create;
declare function create<T>(initialState: ReadonlyNonBasic<T>, options?: CreateOptions): readonly [() => readonly [ReadonlyNonBasic<T>, (newValue: ReadonlyNonBasic<T> | ((oldState: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>)) => void], {
    getState: () => ReadonlyNonBasic<T>;
    /**
     * @deprecated Please use `.setState`, `.replaceState` will remove in 2.0
     */
    replaceState: (newValue: ReadonlyNonBasic<T> | ((oldState: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>)) => void;
    setState: (newValue: ReadonlyNonBasic<T> | ((oldState: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>)) => void;
    forceUpdate: () => void;
    syncState: (newValue: ReadonlyNonBasic<T> | ((oldState: ReadonlyNonBasic<T>) => ReadonlyNonBasic<T>)) => void;
    subscribe: (_callback: (state: ReadonlyNonBasic<T>) => void) => () => void;
    destroy: () => void;
}];
type Store = ReturnType<typeof create<any>>[1];

declare const isClient: boolean;
declare const wrapState: <T = any>(state: T) => T & {
    ready: boolean;
};
declare const persistStore: <T = any>(store: {
    readonly getState: () => any;
    readonly setState: (newValue: any) => void;
    readonly forceUpdate: () => void;
    readonly syncState: (newValue: any) => void;
    readonly subscribe: (callback: (state: any) => void) => () => void;
    readonly destroy: () => void;
}, options: {
    key: string;
    debounce?: number | undefined;
    cache?: Cache | undefined;
    transform?: ((state: T) => T) | undefined;
}) => Promise<() => void>;

declare const usePersist: (_options: Options<any>) => (boolean | (() => null))[];

export { type Store, create, createOne, isClient, persistStore, usePersist, wrapState };
